/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


DEF INPUT PARAMETER cSessionID AS CHARACTER NO-UNDO.

DEF VAR cRoomDescription    AS CHARACTER FORMAT "x(50)" NO-UNDO.
DEF VAR cRoomInventory      AS CHARACTER FORMAT "x(50)" NO-UNDO.
DEF VAR cCommand            AS CHARACTER FORMAT "x(50)" NO-UNDO.
DEF VAR cError              AS CHARACTER NO-UNDO.
DEF VAR cMessage            AS CHARACTER FORMAT "x(50)" NO-UNDO.
  
/* Input what the player wants to do */
  
REPEAT:

  IF cCommand <> "" THEN DO:
  
    RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Command",
                    INPUT cCommand,
                    OUTPUT cError).
  
    RUN ParseCommand.p (INPUT cSessionID).
  
  END.
  
  
  /* Pull up the appropriate room description */
  
  FIND WebState NO-LOCK
  WHERE WebState.SessionID = cSessionID
    AND WebState.Category  = "Map"
    AND WebState.Name      = "CurrentRoom"
  NO-ERROR.
  
  FIND RoomDesc NO-LOCK
  WHERE RoomDesc.RoomNumber = INT(WebState.Data)
  NO-ERROR.
  
  IF AVAILABLE RoomDesc THEN 
    ASSIGN cRoomDescription = RoomDesc.Description.
  
  /* Pull up any messages from the command parser */
  
  FIND WebState NO-LOCK
  WHERE WebState.SessionID = cSessionID
    AND WebState.Category  = "FeedBack"
    AND WebState.Name      = "Message"
  NO-ERROR.
  
  ASSIGN cMessage = WebState.Data.
  
  /* Display the output to the user */
  
  DISPLAY "Natural Language Processing" SKIP 
          "Adventure Game" 
  WITH FRAME M CENTERED.
 
  ASSIGN cRoomDescription = cRoomDescription + "~n" + cRoomInventory.
 
  DISPLAY cRoomDescription VIEW-AS EDITOR SIZE 35 BY 3 SCROLLBAR-VERTICAL
    WITH FRAME RD NO-BOX CENTERED NO-LABEL .
  DISPLAY cMessage 
    WITH FRAME MS NO-BOX CENTERED NO-LABEL .
  
  ASSIGN cCommand = "".
  UPDATE TEXT(cCommand) WITH FRAME C NO-BOX CENTERED NO-LABEL.


END. /* REPEAT */

