/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


DEF INPUT PARAMETER cLogin AS CHARACTER FORMAT "x(30)" NO-UNDO.

DEF VAR cCharacterName AS CHARACTER NO-UNDO.
DEF VAR lNewCharacter  AS LOGICAL NO-UNDO.

DEF VAR cSessionID     AS CHARACTER NO-UNDO.
DEF VAR cLastSessionID AS CHARACTER NO-UNDO.
DEF VAR cError         AS CHARACTER NO-UNDO.

DEF VAR RCSVersion AS CHARACTER INIT "$Header$" NO-UNDO. 

{MakeID3.i}

/* Get the name of the character from the GameLogin.html screen */

ASSIGN cCharacterName = cLogin.

ASSIGN cSessionID = MakeID3(10).

/* Here we determine if this character has been here before.  If so, we */
/* set the previous states to the current session id.                   */

FIND WebState NO-LOCK
WHERE WebState.Category = "Player"
  AND WebState.Name = "Login"
  AND WebState.Data = cCharacterName
NO-ERROR.

ASSIGN lNewCharacter = NOT AVAILABLE WebState.

IF NOT lNewCharacter THEN DO:

  ASSIGN cLastSessionID = WebState.SessionID.

  FOR EACH WebState EXCLUSIVE-LOCK
  WHERE WebState.SessionID = cLastSessionID:

    ASSIGN WebState.SessionID = cSessionID.

  END. /* FOR EACH WebState */

END. /* IF NOT lNewCharacter */

/* If this is the first time for the character, we initialize the states */
/* for the game.                                                         */

IF lNewCharacter THEN DO:

  /* Create the Login State */

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "Player",
                    INPUT "Login",
                    INPUT cCharacterName,
                    OUTPUT cError).

  /* Create the Command State */

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Command",
                    INPUT "",
                    OUTPUT cError).

  /* Create the Current Room State */

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "Map",
                    INPUT "CurrentRoom",
                    INPUT "1",
                    OUTPUT cError).

  /* Create the Message Back State */

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Message",
                    INPUT "",
                    OUTPUT cError).

END. /* IF lNewCharacter */

HIDE ALL NO-PAUSE.

DISPLAY "Welcome" cLogin WITH CENTERED ROW 5 NO-LABEL.

PAUSE.

HIDE ALL NO-PAUSE.

RUN CHUIGame.p (INPUT cSessionID).


