/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/rpg/src/verb/DropItem.p,v 1.1 2003/02/10 05:14:37 sauge Exp $" NO-UNDO.

DEF INPUT PARAMETER cSessionID AS CHARACTER NO-UNDO.

DEF VAR iCurrentRoom  AS INTEGER NO-UNDO.
DEF VAR cCommand      AS CHARACTER NO-UNDO.
DEF VAR cDescription  AS CHARACTER NO-UNDO.
DEF VAR cError        AS CHARACTER NO-UNDO.

/* Pull up what the user sent to us. */

FIND WebState NO-LOCK
WHERE WebState.SessionID = cSessionID
  AND WebState.Category  = "FeedBack"
  AND WebState.Name      = "Command"
NO-ERROR.

ASSIGN cCommand = WebState.Data.

/* Lets see if we can figure out what RPGItem the user is speaking of. */
/* We do this by looping through all words that are type "NOUN" and */
/* see if they match anything in our cCommand.  Note that not all   */
/* NOUN words need to be RPGItems, but if they are, the need cor-      */
/* responding RPGItem records.                                         */

FOR EACH WordType NO-LOCK
WHERE WordType.WordType = "NOUN":

  IF INDEX(cCommand, WordType.Word) <> 0 THEN DO:

    ASSIGN cDescription = WordType.Word.
    LEAVE.

  END. /* IF INDEX(cCommand, WordType.Word) <> 0 */

END. /* FOR EACH WordType */

IF cDescription = "" THEN DO:

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Message",
                    INPUT "Not sure what you speak of....",
                    OUTPUT cError).

  RETURN.

END. /* IF cDescription = "" */

FIND RPGItem EXCLUSIVE-LOCK
WHERE RPGItem.Description = cDescription
NO-ERROR.

IF NOT AVAILABLE RPGItem THEN DO:

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Message",
                    INPUT "Error: Cannot find the item record! " + cDescription,
                    OUTPUT cError).

  RETURN.

END. /* IF NOT AVAILABLE RPGItem */

/* Find out if the user has the item */

FIND WebState NO-LOCK
WHERE WebState.SessionID = cSessionID
  AND WebState.Category = "Player"
  AND WebState.Name = "Login"
NO-ERROR.

IF RPGItem.PersonID <> WebState.Data THEN DO:

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Message",
                    INPUT "You have no such item...",
                    OUTPUT cError).

  RETURN.

END.

/* Find out the room the user is in */

FIND WebState NO-LOCK
WHERE WebState.SessionID = cSessionID
  AND WebState.Category  = "Map"
  AND WebState.Name      = "CurrentRoom"
NO-ERROR.

ASSIGN iCurrentRoom = INT(WebState.Data).

/* Leave the item in the room */

ASSIGN
RPGItem.OnPerson = NO
RPGItem.RoomNumber = iCurrentRoom
RPGItem.PersonID = "".

/* Feed back to the user. */

  RUN WriteState.p (INPUT cSessionID,
                    INPUT "FeedBack",
                    INPUT "Message",
                    INPUT "You have dropped the item...",
                    OUTPUT cError).
