/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


/* Handle movement of the player around the map of the game world. */

DEF INPUT PARAMETER cSessionID AS CHARACTER NO-UNDO.

DEF VAR iCurrentRoom AS INTEGER NO-UNDO.
DEF VAR iNextRoom    AS INTEGER NO-UNDO.
DEF VAR cDirection   AS CHARACTER NO-UNDO.
DEF VAR cMessage     AS CHARACTER NO-UNDO.
DEF VAR cCommand     AS CHARACTER NO-UNDO.
DEF VAR cError       AS CHARACTER NO-UNDO.

/* Find the player's current room */

FIND WebState NO-LOCK
WHERE WebState.SessionID = cSessionID
  AND WebState.Category  = "Map"
  AND WebState.Name      = "CurrentRoom"
NO-ERROR.

ASSIGN iCurrentRoom = INT(WebState.Data).

/* Determine where the player desires to go */
/* Little fast and loose with the grammar here.  We simply look */
/* for keywords since we have passed muster with the grammer    */
/* check.  That rule is [travel verb] [direction]               */

FIND WebState NO-LOCK
WHERE WebState.SessionID = cSessionID
  AND WebState.Category  = "FeedBack"
  AND WebState.Name      = "Command"
NO-ERROR.

ASSIGN cCommand = WebState.Data.

IF INDEX (cCommand, "North") <> 0 THEN ASSIGN cDirection = "North".
ELSE IF INDEX (cCommand, "South") <> 0 THEN ASSIGN cDirection = "South".
ELSE IF INDEX (cCommand, "East") <> 0 THEN ASSIGN cDirection = "East".
ELSE IF INDEX (cCommand, "West") <> 0 THEN ASSIGN cDirection = "West".

/* Determine if the player is going someplace they can't go */
/* If so, then tell them so, else, set the current room to the next room */

FIND RoomMap NO-LOCK
WHERE RoomMap.RoomNumber = iCurrentRoom
NO-ERROR.

ASSIGN cMessage = ""
       iNextRoom = iCurrentRoom.

CASE cDirection:

  WHEN "North" THEN DO:

    IF RoomMap.North = 0 THEN
      ASSIGN cMessage = "You cannot move in that direction!".
    ELSE 
      ASSIGN iNextRoom = RoomMap.North.

  END. /* WHEN "North" THEN */

  WHEN "South" THEN DO:

    IF RoomMap.South = 0 THEN 
      ASSIGN cMessage = "You cannot move in that direction!".
    ELSE 
      ASSIGN iNextRoom = RoomMap.South.

  END. /* WHEN "South" THEN */

  WHEN "East" THEN DO:

    IF RoomMap.East = 0 THEN
      ASSIGN cMessage = "You cannot move in that direction!".
    ELSE 
      ASSIGN iNextRoom = RoomMap.East.

  END. /* WHEN "East" THEN */

  WHEN "West" THEN DO:

    IF RoomMap.West = 0 THEN 
      ASSIGN cMessage = "You cannot move in that direction!".
    ELSE 
      ASSIGN iNextRoom = RoomMap.West.

  END. /* WHEN "West" THEN */

END. /* CASE cDirection: */

/* If we changed rooms, then update the room state */

IF iCurrentRoom <> iNextRoom THEN
  RUN WriteState.p (INPUT cSessionID,
                    INPUT "Map",
                    INPUT "CurrentRoom",
                    INPUT STRING(iNextRoom),
                    OUTPUT cError).

/* Update the message state */

RUN WriteState.p (INPUT cSessionID,
                  INPUT "FeedBack",
                  INPUT "Message",
                  INPUT cMessage,
                  OUTPUT cError).

